/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#define VER         "0.1"
#define BUFFSZ      1024
#define ECLIBINI    "eclib.ini"



void echk_pwddec(unsigned char *data);
void std_err(void);



int main(int argc, char *argv[]) {
    FILE            *fd;
    unsigned char   buff[BUFFSZ + 1],
                    *ptr3 = buff + 3,
                    *limit;

    fputs("\n"
        "Advanced Email Checker passwords decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    fputs("Open data file "ECLIBINI"\n", stdout);
    fd = fopen(ECLIBINI, "rb");
    if(!fd) std_err();

    while(1) {
        if(!fgets(buff, BUFFSZ, fd)) break;

        if(buff[2] != '=') continue;

        switch(buff[1]) {
            case 'A': printf("\n-----------\n Profile:  %s", ptr3); break;
            case 'B': printf(" Server:   %s", ptr3); break;
            case 'C': printf(" Username: %s", ptr3); break;
            case 'D': {
                limit = strchr(ptr3, 0x0d);
                if(!limit) {
                    limit = strchr(ptr3, 0x0a);
                    if(limit) *limit = 0;
                } else *limit = 0;

                echk_pwddec(ptr3);
                printf(" Password: %s\n", ptr3);
            } break;
        }
    }

    fclose(fd);
    fputs("\n"
        "-----------\n"
        "    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



void echk_pwddec(unsigned char *data) {
    int     i = 0;

    while(*data) {
        i &= 7;
        *data++ -= ++i;
    }
}



void std_err(void) {
    perror("\nError");
    fputs("\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    exit(1);
}


